<template>
  <div>
    <modal-new-diet></modal-new-diet>

    <div class="row">
      <div class="ui buttons">
        <button class="ui button">
           {{ count > 1 ? 'Régimes' : 'Régime' }}
        </button>
        <div
          class="or"
          :data-text="count"
        ></div>
        <button
          class="ui positive button"
          @click="openModalNewDiet"
        >
          Ajouter
        </button>
      </div>
    </div>
    <br/>

    <div
      class="ui" :class="columns + ' column grid'"
      v-if="count"
    >
      <div
        class="column"
        v-for="diet in diets"
        :key="diet._id"
      >
        <div class="ui cards">
          <diet-card
            v-bind="diet"
            @removeDiet="removeDiet"
          ></diet-card>
        </div>
      </div>
    </div>

    <div class="ui header" v-else>
      Aucun régime présent
    </div>

  </div>
</template>

<script>
import { mapGetters } from 'vuex'

import { adaptiveColumns } from '@/utils/utils'
import store from '@/store/Store'
import ModalNewDiet from './ModalNewDiet'
import DietCard from './DietCard'

export default {
  name: 'Diets',
  store,
  data () {
    return {
      columns: 'seven'
    }
  },
  beforeCreate () {
    store.dispatch('DietsStore/loadDiets')
      .then(
        (response) => {

        },
        (error) => {
          this.$toastr.e(error.response.data.message)
        }
      )
  },
  created () {
    this.columns = adaptiveColumns()
  },
  mounted () {
    // eslint-disable-next-line
    $(window).on('resize', () => {
      // eslint-disable-next-line
      this.columns = adaptiveColumns()
    })
  },
  methods: {
    removeDiet (id) {
      store.dispatch('DietsStore/removeDiet', id)
        .then((response) => {
          this.$toastr.s(response.name + ' bien supprimé')
        },
        (error) => {
          this.$toastr.e(error.response.data.message)
        })
    },
    openModalNewDiet () {
      // eslint-disable-next-line
      $('#new-diet-modal')
        .modal('show')
    }
  },
  computed: {
    ...mapGetters({
      diets: 'DietsStore/diets',
      count: 'DietsStore/count'
    })
  },
  components: {
    DietCard,
    ModalNewDiet
  }
}
</script>
